<template>
  <v-container grid-list-md text-xs-center>
      <loading :active.sync="isLoading"
        :is-full-page="true"></loading>
      <template  v-if="recipe != null">
        <v-layout row wrap>
          <v-flex mb-4>
            <h1 class="display-2 font-weight-bold mb-3">
              {{ recipe.name }}
            </h1>
            <p class="subheading font-weight-regular">
              Portions: {{ recipe.portions }} - Calories: {{ recipe.calories }}
            </p>
          </v-flex>
        </v-layout>
        <v-list>
          <v-subheader>Ingredients</v-subheader>

          <v-list-tile
            v-for="ingredient in recipe.ingredients"
            :key="ingredient.id"
          >
            <v-list-tile-action>
              <v-icon color="blue">fas fa-hamburger</v-icon>
            </v-list-tile-action>

            <v-list-tile-content>
              <v-list-tile-title v-text="ingredientText(ingredient)"></v-list-tile-title>
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
        <v-layout row wrap>
        <v-flex xs12 mt-3>
          <v-card>
            <v-card-title primary-title>
              <div>
                <h3 class="headline mb-0">Directions</h3>
                <span v-html="formattedDirections"></span>
              </div>
            </v-card-title>
          </v-card>
        </v-flex>
        </v-layout>
      </template>
      <v-layout row wrap v-else-if="!isLoading">
        <v-flex mb-4>
          <p class="subheading font-weight-regular">
            Recipe was not found!
          </p>
        </v-flex>
      </v-layout>
  </v-container>
</template>

<script>
import Loading from 'vue-loading-overlay'
import 'vue-loading-overlay/dist/vue-loading.css'

export default {
  data: () => ({
    recipe: null,
    isLoading: true
  }),
  computed: {
    formattedDirections () {
      return this.recipe.directions.replace(/\n/g, '<br />')
    }
  },
  components: {
    Loading
  },
  methods: {
    ingredientText (ingredient) {
      if (ingredient.measurement) {
        return ingredient.quantity + ingredient.measurement + ' of ' + ingredient.name
      }
      return ingredient.quantity + ' ' + ingredient.name
    }
  },
  mounted () {
    this.axios
      .get('/api/recipes/' + this.$route.params.id)
      .then(response => {
        this.isLoading = false
        this.recipe = response.data
      })
      .catch(error => {
        this.isLoading = false
        console.error(error)
      })
  }
}
</script>
